Attribute VB_Name = "mDeclaration"
Option Explicit

'/* Declaration Types
'    
Public Type POINTAPI
    x As Long
    y As Long
End Type

Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Public Type MENUITEMINFO
    cbSize As Long
    fMask As Long
    fType As Long
    fState As Long
    wID As Long
    hSubMenu As Long
    hbmpChecked As Long
    hbmpUnchecked As Long
    dwItemData As Long
    dwTypeData As String
    cch As Long
End Type

Public Type DRAWITEMSTRUCT
    CtlType As Long
    CtlID As Long
    ItemID As Long
    itemAction As Long
    itemState As Long
    hwndItem As Long
    hdc As Long
    rcItem As RECT
    itemData As Long
End Type

Public Type MEASUREITEMSTRUCT
    CtlType As Long
    CtlID As Long
    ItemID As Long
    itemWidth As Long
    itemHeight As Long
    itemData As Long
End Type


'/* Declaration API Functions
'    API 
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal ByteLen As Long)
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Declare Function GetMenu Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function GetSubMenu Lib "user32.dll" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Public Declare Function GetMenuItemCount Lib "user32.dll" (ByVal hMenu As Long) As Long
Public Declare Function GetMenuItemInfo Lib "user32" Alias "GetMenuItemInfoA" (ByVal hMenu As Long, ByVal un As Long, ByVal b As Long, lpMenuItemInfo As MENUITEMINFO) As Long
Public Declare Function SetMenuItemInfo Lib "user32.dll" Alias "SetMenuItemInfoA" (ByVal hMenu As Long, ByVal un As Long, ByVal bool As Boolean, ByRef lpcMenuItemInfo As MENUITEMINFO) As Long
Public Declare Function GetMenuString Lib "user32" Alias "GetMenuStringA" (ByVal hMenu As Long, ByVal wIDItem As Long, ByVal lpString As String, ByVal nMaxCount As Long, ByVal wFlag As Long) As Long
Public Declare Function MenuItemFromPoint Lib "user32.dll" (ByVal hwnd As Long, ByVal hMenu As Long, ByVal x As Long, ByVal y As Long) As Long
Public Declare Function HiliteMenuItem Lib "user32.dll" (ByVal hwnd As Long, ByVal hMenu As Long, ByVal wIDHiliteItem As Long, ByVal wHilite As Long) As Long
Public Declare Function GetMenuState Lib "user32.dll" (ByVal hMenu As Long, ByVal wID As Long, ByVal wFlags As Long) As Long
Public Declare Function GetMenuItemID Lib "user32.dll" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Public Declare Function SetMenuItemBitmaps Lib "user32.dll" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal hBitmapUnchecked As Long, ByVal hBitmapChecked As Long) As Long

Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Public Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Public Declare Function FrameRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Public Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Public Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long

Public Declare Function GetSysColor Lib "user32.dll" (ByVal nIndex As Long) As Long

Public Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hdc As Long) As Long
Public Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function GetPixel Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Public Declare Function SetPixel Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Public Declare Function DeleteDC Lib "gdi32.dll" (ByVal hdc As Long) As Long


'/* Declaration Constants
'    
Public Const GWL_WNDPROC As Long = -4

Public Const WM_DESTROY               As Long = &H2
Public Const WM_CLOSE                 As Long = &H10
Public Const WM_MOUSEMOVE As Long = &H200
Public Const WM_NCMOUSEMOVE As Long = &HA0
Public Const HTMENU As Long = 5

Public Const MIIM_TYPE As Long = &H10
Public Const MIIM_ID As Long = &H2
Public Const MIIM_STATE As Long = &H1
Public Const MIIM_SUBMENU As Long = &H4
Public Const MIIM_CHECKMARKS As Long = &H8

Public Const MF_OWNERDRAW As Long = &H100&
Public Const MF_HILITE As Long = &H80&
Public Const MF_UNHILITE As Long = &H0&
Public Const MF_SEPARATOR As Long = &H800&
Public Const MF_CHECKED As Long = &H8&
Public Const MF_UNCHECKED As Long = &H0&
Public Const MF_BYCOMMAND = &H0&
Public Const MF_BYPOSITION = &H400&
Public Const MF_RIGHTJUSTIFY As Long = &H4000&
Public Const MF_MENUBREAK As Long = &H40&
Public Const MF_MENUBARBREAK As Long = &H20&
Public Const MF_STRING As Long = &H0&
Public Const MF_ENABLED As Long = &H0&

Public Const MFT_RADIOCHECK As Long = &H200&
Public Const MFT_STRING As Long = MF_STRING
Public Const MFT_SEPARATOR As Long = MF_SEPARATOR
Public Const MFT_RIGHTJUSTIFY As Long = MF_RIGHTJUSTIFY
Public Const MFT_MENUBREAK As Long = MF_MENUBREAK
Public Const MFT_MENUBARBREAK As Long = MF_MENUBARBREAK

Public Const MFS_HILITE As Long = MF_HILITE
Public Const MFS_CHECKED As Long = MF_CHECKED
Public Const MFS_UNCHECKED As Long = MF_UNCHECKED
Public Const MFS_GRAYED As Long = &H3&
Public Const MFS_DISABLED As Long = MFS_GRAYED
Public Const MFS_ENABLED As Long = MF_ENABLED

Public Const WM_DRAWITEM As Long = &H2B
Public Const WM_MEASUREITEM As Long = &H2C

Public Const ODS_CHECKED As Long = &H8
Public Const ODS_FOCUS As Long = &H10
Public Const ODS_SELECTED As Long = &H1
Public Const ODA_FOCUS As Long = &H4

Public Const TRANSPARENT = 1

Public Const COLOR_BACKGROUND As Long = 1
Public Const COLOR_MENU As Long = 4
Public Const COLOR_BTNFACE As Long = 15

Public Const DT_CENTER = &H1
Public Const DT_RIGHT As Long = &H2
Public Const DT_LEFT As Long = &H0
Public Const DT_SINGLELINE = &H20
Public Const DT_BOTTOM As Long = &H8
Public Const DT_VCENTER As Long = &H4
Public Const DT_TOP As Long = &H0


Public Const DP_COLOR As Long = 0
Public Const DP_SHADOW As Long = 1

'/* Public Variable
'   Public 
Public COL_MENU As Long
Public COL_MENU_HILITE As Long
Public COL_SUBMENU As Long
Public COL_SUBMENU_HILITE As Long
Public COL_MENUBORDER As Long
Public COL_MENUTEXT As Long
Public COL_MENUTEXT_HILITE As Long
Public COL_SUBMENUTEXT As Long
Public COL_SUBMENUTEXT_HILITE As Long
Public COL_SUBMENUTEXT_GRAYED As Long
Public COL_BITMAP_BACKGROUND As Long
Public COL_BITMAP_SHADOW As Long
Public COL_BITMAP_MASK As Long
Public COL_SEPARATOR As Long

' Old window procedure
'   
Public wlOldProc As Long
