Attribute VB_Name = "mTools"
Option Explicit

'/* C++ Macros.
'   The LOWORD macro retrieves the low-order word from the given 32-bit value.
'   Useful when converting code from C++
Public Function LoWord(ByVal LongIn As Long) As Integer
     If (LongIn And &HFFFF&) > &H7FFF Then
          LoWord = (LongIn And &HFFFF&) - &H10000
     Else
          LoWord = LongIn And &HFFFF&
     End If
End Function

'/* C++ Macros.
'   The HIWORD macro retrieves the high-order word from the given 32-bit value.
'   Useful when converting code from C++
Public Function HiWord(ByVal LongIn As Long) As Integer
     HiWord = (LongIn And &HFFFF0000) \ &H10000
End Function

'/* C++ Macros.
'   The MAKEPOINTS macro converts a value that contains the x- and y-coordinates of
'   a point into a POINTS structure.
'   Useful when converting code from C++
Public Function MakePoint(ByVal lParam As Long) As POINTAPI
    MakePoint.x = LoWord(ByVal lParam)
    MakePoint.y = HiWord(ByVal lParam)
End Function

'/* C++ Macros.
'   Creates a Long value using Low and High integers
'   Useful when converting code from C++
Public Function MakeLong(ByVal LoWord As Integer, ByVal HiWord As Integer) As Long
  MakeLong = CLng(LoWord)
  Call CopyMemory(ByVal VarPtr(MakeLong) + 2, HiWord, 2)
End Function

'/* This function calculate the amount of  menu items.
'        .
Public Function CalcMenuItemCount(ByVal hwnd As Long, ByVal hMenu As Long) As Long
Dim i As Long, j As Long
Dim hSubMenu As Long
    j = GetMenuItemCount(ByVal hMenu&)
    If GetMenu(ByVal hwnd) <> hMenu Then CalcMenuItemCount = 1
    For i = 0 To j - 1
        hSubMenu = GetSubMenu(ByVal hMenu&, i&)
        If hSubMenu <> 0 Then
            CalcMenuItemCount = CalcMenuItemCount + CalcMenuItemCount(ByVal hwnd&, ByVal hSubMenu&)
        Else
            CalcMenuItemCount = CalcMenuItemCount + 1
        End If
    Next i
End Function

'/* This function draw the RECT and fill it.
'         .
Public Sub FillRectangle(ByVal hdc As Long, rc As RECT, ColorRC As Long)
Dim hBr As Long
    '    
    hBr = CreateSolidBrush(ColorRC)
    '     
    Call FillRect(hdc, rc, hBr)
    '  
    Call DeleteObject(hBr)
End Sub

'/* This function set the "Owner-drawn" type for each item menu.
'       "Owner-drawn"    .
Public Function SetOwnerDrawn(ByVal hMenu As Long)
Dim MII As MENUITEMINFO
Dim i As Long, j As Long
Dim lngMenuItemCount As Long, hSubMenu As Long
    MII.fMask = MIIM_TYPE
    MII.cbSize = LenB(MII)
    lngMenuItemCount = GetMenuItemCount(ByVal hMenu)
    For i = 0 To lngMenuItemCount - 1
        Call GetMenuItemInfo(ByVal hMenu, ByVal i&, ByVal 1&, MII)
        MII.fType = MII.fType Or MF_OWNERDRAW
        Call SetMenuItemInfo(ByVal hMenu, ByVal i&, ByVal 1&, MII)
        hSubMenu = GetSubMenu(ByVal hMenu, ByVal i&)
        If hSubMenu <> 0 Then Call SetOwnerDrawn(ByVal hSubMenu)
    Next i
End Function

'/* This function cut bitmap index from menu item string.
'         bitmap
Public Function CutBitmapIndex(ByVal strMenuSrting As String) As String
Dim i As Long, j As Long
    i = InStr(1, strMenuSrting, Chr(91), vbTextCompare)
    j = InStr(i, strMenuSrting, Chr(93), vbTextCompare)
    CutBitmapIndex = Mid$(strMenuSrting, 1, i - 1) & Mid$(strMenuSrting, j + 1, Len(strMenuSrting) - j)
End Function

'/* This function check the menu item is have the bitmap
'      bitmap    
Public Function IsHavingBitmap(ByVal strMenuSrting As String) As Long
Dim i As Long, j As Long
    i = InStr(1, strMenuSrting, Chr(91), vbTextCompare)
    If i <> 0 Then
        j = InStr(i, strMenuSrting, Chr(93), vbTextCompare)
        If j <> 0 Then
            IsHavingBitmap = CLng(Mid$(strMenuSrting, i + 1, j - i - 1))
        End If
    End If
End Function

'/* This function check the menu item is have the "Disabled" state.
'          "Disabled"
Public Function IsDisabled(ByVal hwnd As Long, ByVal ItemID As Long) As Boolean
Dim MII As MENUITEMINFO
Dim hMenu As Long
    hMenu = GetMenu(ByVal hwnd&)
    MII.fMask = MIIM_STATE
    MII.cbSize = LenB(MII)
    Call GetMenuItemInfo(ByVal hMenu&, ByVal ItemID&, ByVal 0&, MII)
    IsDisabled = ((MII.fState And MFS_DISABLED) = MFS_DISABLED)
End Function

'/* This function check the menu item is have the SubMenu
'        SubMenu
Public Function IsHavingSabMenu(ByVal hwnd As Long, ByVal ItemID As Long) As Boolean
Dim MII As MENUITEMINFO
Dim hMenu As Long
     hMenu = GetMenu(ByVal hwnd&)
     MII.fMask = MIIM_SUBMENU
     MII.cbSize = LenB(MII)
     Call GetMenuItemInfo(ByVal hMenu&, ByVal ItemID&, ByVal 0&, MII)
     If MII.hSubMenu <> 0 Then IsHavingSabMenu = True
End Function

'/* This function check the menu item is have the "Shortcut".
'        "" 
Public Function IsShortcut(ByVal strMenuItem As String) As Boolean
    If InStr(strMenuItem$, Chr(9)) Then IsShortcut = True
End Function

'/* This function check the menu item is have the "separator" type.
'         ""
Public Function IsSeparator(ByVal hwnd As Long, ByVal ItemID As Long) As Boolean
Dim MII As MENUITEMINFO
Dim hMenu As Long
     hMenu = GetMenu(ByVal hwnd&)
     MII.fMask = MIIM_TYPE
     MII.cbSize = LenB(MII)
     Call GetMenuItemInfo(ByVal hMenu&, ByVal ItemID&, ByVal 0&, MII)
     IsSeparator = ((MII.fType And MFT_SEPARATOR) = MFT_SEPARATOR)
End Function

'/* This function check the menu item is have the "check" state.
'          "check"
Public Function IsChecked(ByVal hwnd As Long, ByVal ItemID As Long) As Boolean
Dim MII As MENUITEMINFO
Dim hMenu As Long
    hMenu = GetMenu(ByVal hwnd&)
    MII.fMask = MIIM_STATE
    MII.cbSize = LenB(MII)
    Call GetMenuItemInfo(ByVal hMenu&, ByVal ItemID&, ByVal 0&, MII)
    'If (MII.fState And MFS_CHECKED) Or (MII.fState And MFS_UNCHECKED) Then
    IsChecked = ((MII.fState And MFS_CHECKED) = MFS_CHECKED)
End Function

'/* This function check the menu item is at top row.
'     ,        
Public Function IsMenuItemInTopRow(ByVal hwnd As Long, ByVal ItemID As Long) As Boolean
Dim MII As MENUITEMINFO
Dim hMenu As Long, lngMenuItemCount As Long, i As Long
    hMenu = GetMenu(ByVal hwnd&)
    lngMenuItemCount = GetMenuItemCount(ByVal hMenu)
    For i = 0 To lngMenuItemCount - 1
        MII.fMask = MIIM_ID
        MII.cbSize = LenB(MII)
        Call GetMenuItemInfo(ByVal hMenu&, ByVal i&, ByVal 1&, MII)
        If MII.wID = ItemID Then
            IsMenuItemInTopRow = True
            Exit Function
        End If
    Next i
    IsMenuItemInTopRow = False
End Function

'/* This function draw TRANSPARENT bitmap
'       
Public Sub DrawBitmap(ByVal hdc As Long, ByVal lX As Long, ByVal lY As Long, ByVal lBitmap As Long, PicRC As RECT, ByVal flag As Long)
Dim hDcSource As Long
Dim hNewPicture As Long
Dim tempColor As Long
Dim x As Long, y As Long
    
    '      ...
    If lBitmap = 0 Then Exit Sub

    '//   
    hDcSource = CreateCompatibleDC(ByVal hdc&)
    '//     
    hNewPicture = SelectObject(ByVal hDcSource&, ByVal LoadResPicture(lBitmap&, vbResBitmap))

    '   
    For x = 0 To 20 - 1
        For y = 0 To 20 - 1
            tempColor = GetPixel(hDcSource, x, y)
            '         
            If COL_BITMAP_MASK <> tempColor Then
                '         rcAreaPicture
                Select Case flag
                    '    
                    Case DP_COLOR
                        Call SetPixel(hdc, PicRC.Left + x + lX, PicRC.Top + y + lY, tempColor)
                    '         
                    Case DP_SHADOW
                        If x < 19 And y < 19 Then
                            Call SetPixel(hdc, PicRC.Left + x + lX, PicRC.Top + y + lY, COL_BITMAP_SHADOW)
                        End If
                End Select
            End If
        Next
    Next
    '  
    Call SelectObject(ByVal hDcSource&, ByVal hNewPicture&)
    '  
    Call DeleteDC(ByVal hDcSource&)

End Sub

